#include <cstdio>

struct Nil {};

template <typename Head,typename Tail> 
  struct Pair
  {
    typedef Head head;
    typedef Tail tail;
  };

template <int n>
  struct Value 
  {
    typedef Value<n> type;
    typedef Pair<type,Nil> list;
    enum  { value = n };
  };

template <typename List> 
  struct sum_list 
  {    
    enum { value = List::head::type::value + sum_list< typename List::tail >::value };
  };

template <>
  struct sum_list<Nil>
  {
    enum { value = 0 };
  };

template <int n,template<int> class F>
  struct Range
  {
    typedef Pair< typename F<n>::type ,typename Range<n - 1,F>::list > list;
  };
template <template<int> class F>
  struct Range<0,F>
  {
    typedef Pair< F<0>,Nil> list;
  };

template<int n,typename List>
  struct At
  {    
    typedef typename At<n-1,typename List::tail>::item item;
  };

template<typename List>
  struct At<0,List>
  {
    typedef typename List::head item;
  };

template<int n,typename List>
  struct Remove
  {    
    typedef Pair<typename List::head,typename Remove<n-1,typename List::tail>::list> list;
  };
template<typename List>
  struct Remove<0,List>
  {
    typedef typename List::tail list;
  };

template<typename List>
  struct list 
  {
    static void show() 
    {
      printf("%d ",List::head::value);
      list<typename List::tail>::show();
    }
  };
template<>
  struct list<Nil>
  {
    static void show()
    {
      printf("\n");
    }
  };

template<int n,typename List,typename Elem>
  struct Insert
  {
    typedef Pair<typename List::head,typename Insert<n-1,typename List::tail,Elem>::list> list;    
  };
template<typename List,typename Elem>
  struct Insert<0,List,Elem>
  {
    typedef Pair<Elem,List> list;    
  };

template<int n,int v>
  struct Cell
  {
    enum { number = n , value = v};
  };

template<int i,int j,typename List>
  struct Swap
  {
    typedef typename At<i,List>::item I;
    typedef typename At<j,List>::item J;
    typedef typename  Insert<
                        j,
                        typename Remove
                        <
                          j,
                          typename Insert
                          <
                            i,
                            typename  Remove
                                      <
                                        i,
                                        List
                                      >::list,
                            J
                          >::list
                        >::list,
                        I
                      >::list list;
  };

template <bool condition,typename Then,typename Else>
  struct IF
  {
    typedef Then ret;
  };

template <typename Then, typename Else>
  struct IF<false, Then, Else>
  {
    typedef Else ret;
  };

template<typename A,typename B>
  struct Max
  {
    const static bool b = A::value < B::value;
    typedef typename IF<b,B,A>::ret ret;
  };

template<typename List>
  struct Length
  {
    enum {value = 1 + Length<typename List::tail>::value };
  };
template<>
  struct Length<Nil>
  {
    enum { value = -1 };
  };

template<typename Head,typename Tail>
  struct Sorted
  {  
    typedef typename At<0,Tail>::item B;    
    enum { value = (int)Head::value < (int)B::value };
  };

template<typename A>
  struct Sorted<A,Nil>
  {
    enum { value = 1 };
  };

template<typename List> 
  struct SortedList
  {
    enum { value = Sorted<typename List::head,typename List::tail>::value && SortedList<typename List::tail>::value };
  };
template<>
  struct SortedList<Nil>
  {
    enum { value = 1 };
  };

template<typename Head,typename Tail>
  struct Sort
  {
    typedef typename At<0,Tail>::item I;
    typedef typename Remove<0,Tail>::list L;
    const static bool b = (int)Head::value > (int)I::value;
    typedef typename IF< b, Pair< I, Pair< Head, L> >, Pair < Head, Pair< I, L > > >::ret list;
  };

template<typename Head>
  struct Sort<Head,Nil>
  {
    typedef Pair<Head,Nil> list;
  };

template<typename List>
  struct SortList
  {
    typedef typename Sort<typename List::head,typename SortList<typename List::tail>::list >::list list;    
  };

template<>
  struct SortList<Nil>
  {
    typedef Nil list;
  };

template<typename A>
  struct ListBox
  {
    typedef A list;
  };

template<bool S,typename List>
  struct FinalSortList
  {
    typedef typename SortList<List>::list l;
    const static bool b = SortedList<l>::value;
    typedef typename FinalSortList<b,l>::list list;
  };

template<typename List>
  struct FinalSortList<true,List>
  {
    typedef List list;
  };

template<typename List>
  struct FinalSort
  { 
    const static bool b = SortedList<List>::value;
    typedef typename FinalSortList<b,List>::list list;
  };


int main()
{
  list< FinalSort< Range<40,Value>::list >::list >::show();
  return 0;
}

