#include <iostream>
#include <typeinfo>

using namespace std;

#define TYPELIST_1(T1)  TypeList<T1, NullType>
#define TYPELIST_2(T1, T2) TypeList<T1, TYPELIST_1(T2)>
#define TYPELIST_3(T1, T2, T3) TypeList<T1, TYPELIST_2(T2, T3)>
#define TYPELIST_4(T1, T2, T3, T4) TypeList<T1, TYPELIST_3(T2, T3, T4)>
#define V(T1) Value<T1>
#define ShowList(T1) T1::ShowValues()
#define Print(T1) T1::Show();
#define Length(T1) TemplateLength<T1>::ret
#define At(T1,T2) TemplateAt<T1,T2>::ret
#define SumList(T1) TemplateSumList< T1 >::ret
#define Remove(T1,T2) TemplateRemove<T1,T2>::ret
#define Insert(T1,T2,T3) TemplateInsert<T1,T2,T3>::ret
#define Swap(T1,T2,T3) TemplateSwap<T1,T2,T3>::ret
#define Map(T1,T2) TemplateMap<T1,T2>::ret
#define Fold(T1,T2) TemplateFold<T1,T2>::ret
#define LazyFibo TemplateLazyFibo<0,1>
#define LazyNatural TemplateLazyNatural<0,1>
#define Take(T1,T2) TemplateTake<T1,T2>::ret
#define Filter(T1,T2) TemplateFilter<T1,T2>::ret
#define Mod(T1) TemplateMod<T1>::C

struct NullType {};

template <int v>
  struct Value
  {
    const static int ret = v;
    static void Show()
    {
      cout << ret << endl;
    };
  };

template <typename H,typename T>
  struct TypeList
  {
    typedef H Head;
    typedef T Tail;
    static void ShowValues()
    {
      cout << Head::ret << " ";      
      Tail::ShowValues();
      //TypeList<typename Tail::Head,typename Tail::Tail>::ShowValues();
    };
    static void ShowTypes()
    {
      cout << typeid(Head::ret).name() << " ";
      Tail::ShowTypes();
      //TypeList<typename Tail::Head,typename Tail::Tail>::ShowTypes();
    };

  };

template <typename H>
  struct TypeList<H,NullType>
  {
    typedef H Head;
    typedef NullType Tail;
    static void ShowValues() 
    {
      cout << Head::ret << endl;  
    };   
    static void ShowTypes() 
    {
      cout << typeid(Head::ret).name() << endl;  
    };   
  };

template <typename L>
  struct TemplateLength
  {
    const static int t = 1 + TemplateLength<typename L::Tail>::t;
    typedef Value< t > ret;
  };

template <>
  struct TemplateLength<NullType>
  {
    const static int t = 0;
    typedef Value< 0 > ret;
  };

template<int n,typename L>
  struct TemplateAt
  {   
    typedef typename TemplateAt<n-1,typename L::Tail>::ret ret;
  };

template<typename L>
  struct TemplateAt<0,L>
  {
    typedef typename L::Head ret;
  };

template <typename L> 
  struct TemplateSumList 
  {    
    const static int t = L::Head::ret + TemplateSumList< typename L::Tail >::t;
    typedef Value < t > ret;
  };

template <>
  struct TemplateSumList<NullType>
  {
    const static int t = 0;
    typedef Value< 0 > ret;
  };

template<int n,typename L>
  struct TemplateRemove
  {    
    typedef TypeList<typename L::Head,typename TemplateRemove<n - 1,typename L::Tail>::ret > ret;
  };
template<typename L>
  struct TemplateRemove<0,L>
  {
    typedef typename L::Tail ret;
  };

template<int n,typename L,typename E>
  struct TemplateInsert
  {
    typedef TypeList< 
              typename  L::Head,
              typename  TemplateInsert<
                                        n - 1,
                                        typename L::Tail,
                                        E
                                      >::ret
                    > ret;    
  };

template<typename L,typename E>
  struct TemplateInsert<0,L,E>
  {
    typedef TypeList<E,L> ret;
  };

template<int i,int j,typename L>
  struct TemplateSwap
  {
    typedef typename TemplateAt<i,L>::ret I;
    typedef typename TemplateAt<j,L>::ret J;
    typedef typename TemplateInsert<
                        j,
                        typename TemplateRemove
                        <
                          j,
                          typename TemplateInsert
                          <
                            i,
                            typename  TemplateRemove
                                      <
                                        i,
                                        L
                                      >::ret,
                            J
                          >::ret
                        >::ret,
                        I
                      >::ret ret;
  };



template<template<class> class F,typename L>
  struct TemplateMap
  {    
    typedef TypeList<typename F< typename L::Head>::ret,typename TemplateMap<F,typename L::Tail>::ret > ret;
  };

template<template<class> class F>
  struct TemplateMap<F,NullType>
  {
    typedef NullType ret;
  };

template <typename V>
  struct FunctorSquare
  {
    const static int t = V::ret * V::ret;
    typedef Value< t > ret;
  };

template <typename X,typename Y>
  struct FoldFunctorSum
  {
    typedef Value< X::ret + Y::ret > ret;
  };

template<template<class,class> class F,typename L,typename D = Value<0> >
  struct TemplateFold
  {
    typedef typename F<D,typename L::Head>::ret r;
    typedef typename TemplateFold<F,typename L::Tail,r>::ret ret;
  };

template<template<class,class> class F,typename D>
  struct TemplateFold<F,NullType,D>
  {
    typedef D ret;
  };

template <int i, int j>
  struct TemplateLazyFibo
  {
    typedef Value< i > ret;
    typedef TemplateLazyFibo<i + j,i> next;
  };

template <>
  struct TemplateLazyFibo<0,1>
  {
    typedef Value< 1 > ret;
    typedef TemplateLazyFibo<1,1> next;
  };

template <int i, int j>
  struct TemplateLazyNatural
  {
    typedef Value< i > ret;
    typedef TemplateLazyNatural<i + j,j> next;
  };

template <>
  struct TemplateLazyNatural<0,1>
  {
    typedef Value< 1 > ret;
    typedef TemplateLazyNatural<2,1> next;
  };

template <int n,typename Lazy>
  struct TemplateTake
  {
    typedef TypeList<typename Lazy::ret,typename TemplateTake<n - 1,typename Lazy::next>::ret > ret;
  };

template <typename Lazy>
  struct TemplateTake<0,Lazy>
  {
    typedef TypeList<typename Lazy::ret,NullType> ret;
  };

template <int b,typename T,typename E>
  struct TemplateIf
  {
    typedef T ret;
  };

template <typename T,typename E>
  struct TemplateIf<false,T,E>
  {
    typedef E ret;
  };

template <template <class> class F,typename L>
  struct TemplateFilter
  {
    typedef typename F<typename L::Head>::ret b;
    typedef typename  TemplateIf< 
                                  b::ret, 
                                  TypeList<
                                            typename L::Head, 
                                            typename TemplateFilter<F,typename L::Tail>::ret 
                                          >,
                                  typename TemplateFilter<F,typename L::Tail>::ret 
                                >::ret ret;
  };

template <template<class> class F>
  struct TemplateFilter<F,NullType>
  {
    typedef NullType ret;
  };

template <typename X>
  struct TemplateMod
  {
    template <typename Y>
    struct C
    {
      const static int t = (Y::ret % X::ret);
      typedef Value<t> ret;
    };
  };

/*
template <int n,typename L>
  struct TemplateEratos_1
  {
    typedef TypeList<
                     typename L::Head,
                     typename TemplateEratos_1<
                              n - 1,
                              typename TemplateFilter<
                               typename TemplateMod<typename L::Head>::C,
                               typename L::Tail
                                                     >::ret 
                                              >::ret 
                    > ret;
  };

template <typename L>
  struct TemplateEratos_1<0,L>
  {
    typedef TypeList<typename L::ret,NullType> ret;
  };

template <typename X>
  struct TemplateEratos
  {
    typedef typename TemplateEratos_1<X::ret, typename TemplateTake<X::ret,TemplateLazyNatural<0,1> >::ret >::ret ret;
  };
*/

template <typename X>
  struct Odd
  {
    const static int t = (X::ret % 2);
    typedef Value<t> ret;
  };




int main()
{
  /*
  typedef TYPELIST_4( V(3), V(1), V(5), V(11) ) one;
  ShowList( one );
  Print( Length(one) );
  Print( At(1,one) );
  Print( SumList(one) );

  cout << endl;

  typedef Remove(1,one) two;
  ShowList( two );
  Print( Length(two) );
  Print( At(1,two) );
  Print( SumList(two) );

  cout << endl;

  typedef Insert(1,one,V(42)) three;
  ShowList( three );
  Print( Length(three));
  Print( At(1,three) );
  Print( SumList(three) );

  cout << endl;
  
  typedef Swap(1,4,three) four;
  ShowList( four );
  Print( Length(four) );
  Print( At(1,four) );
  Print( SumList(four) );

  cout << endl;
  

  typedef TYPELIST_4( V(1), V(2), V(3), V(4) ) five;
  ShowList( Map(FunctorSquare, five) );  
  Print ( Fold (FoldFunctorSum,five) );
  ShowList(Take(30, LazyFibo));
  */
  //ShowList( Filter( Odd,Take(30,LazyFibo) ) );
  ShowList(
            Filter(
              Mod( V(3) ),
              Filter(
                      Mod( V(2) ),
                      Remove(0, Take(30,LazyNatural ) )
              )
            )
          );
  return 0;
};
